'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ms = require('ms');

var _ms2 = _interopRequireDefault(_ms);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _fbemitter = require('fbemitter');

var _generatorForeach = require('generator-foreach');

var _generatorForeach2 = _interopRequireDefault(_generatorForeach);

var _terminalKit = require('terminal-kit');

var _terminalKit2 = _interopRequireDefault(_terminalKit);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _say2 = require('say');

var _say3 = _interopRequireDefault(_say2);

var _coMap = require('co-map');

var _coMap2 = _interopRequireDefault(_coMap);

var imageToAscii = _bluebird2['default'].promisify(require('image-to-ascii'));
var fs = _bluebird2['default'].promisifyAll(require('fs'));
var say = _bluebird2['default'].promisifyAll(_say3['default']);
var termkit = _bluebird2['default'].promisifyAll(_terminalKit2['default']);
var debug = (0, _debug2['default'])('alphabet-cli:App');
var VOICE = 'us1';

var App = (function (_EventEmitter) {
  _inherits(App, _EventEmitter);

  function App() {
    _classCallCheck(this, App);

    _get(Object.getPrototypeOf(App.prototype), 'constructor', this).call(this);
    var ctx = this;
    return (0, _co2['default'])(_regeneratorRuntime.mark(function callee$2$0() {
      return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
        while (1) switch (context$3$0.prev = context$3$0.next) {
          case 0:
            context$3$0.next = 2;
            return ctx.init();

          case 2:
          case 'end':
            return context$3$0.stop();
        }
      }, callee$2$0, this);
    }))['catch'](function (err) {
      console.err(err);
      process.exit();
    });
  }

  _createClass(App, [{
    key: 'init',
    value: _regeneratorRuntime.mark(function init() {
      var term, inputs;
      return _regeneratorRuntime.wrap(function init$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            this._validCount = 0;
            this._count = 0;
            this.addListener('nextcard', this.nextCard.bind(this));
            this.sprites = {};
            context$2$0.next = 6;
            return termkit.getDetectedTerminalAsync();

          case 6:
            this.term = context$2$0.sent;
            term = this.term;
            inputs = this.inputs;

            this.viewport = _terminalKit.ScreenBuffer.create({
              dst: term,
              width: Math.min(term.width),
              height: Math.min(term.height - 1),
              y: 2
            });
            term.hideCursor();
            term.grabInput();
            term.on('key', inputs.bind(this));
            context$2$0.next = 15;
            return this.initAssets();

          case 15:
            this.nextCard();
            this.initViewPort();
            this.initBackground();
            this.animate();
            debug('initialized...');

          case 20:
          case 'end':
            return context$2$0.stop();
        }
      }, init, this);
    })
  }, {
    key: 'initAssets',
    value: _regeneratorRuntime.mark(function initAssets() {
      var term, assetDir, assets, ascii;
      return _regeneratorRuntime.wrap(function initAssets$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            term = this.term;
            assetDir = __dirname + '/buffers';

            debug(assetDir);
            context$2$0.next = 5;
            return fs.readdirAsync(assetDir);

          case 5:
            assets = context$2$0.sent;
            ascii = {};

            assets = assets.map(function (file) {
              return _path2['default'].resolve(__dirname + '/buffers/' + file);
            });
            debug(assets);
            assets.forEach(function (bufferFile) {
              var buffer = fs.readFileSync(bufferFile, 'utf8');
              bufferFile = bufferFile.match(/([A-Z])\.txt$/)[1];
              bufferFile = bufferFile.toLowerCase();
              ascii[bufferFile] = buffer;
            });
            this._assets = ascii;

          case 11:
          case 'end':
            return context$2$0.stop();
        }
      }, initAssets, this);
    })
  }, {
    key: 'nextCard',
    value: function nextCard() {
      debug('#nextCard');
      this._count++;
      var cardKeys = _lodash2['default'].keys(this._assets);
      var keyNum = _lodash2['default'].random(0, cardKeys.length - 1);
      this._cardKey = cardKeys[keyNum];
      var card = this._assets[this._cardKey];
      this._nextCard = card;
      this.sprites.currentCard = card;
      say.speak(VOICE, this._cardKey);
    }
  }, {
    key: 'initViewPort',
    value: function initViewPort() {
      var term = this.term;

      this.viewport = _terminalKit.ScreenBuffer.create({
        dst: term,
        width: Math.min(term.width),
        height: Math.min(term.height - 1),
        y: 2
      });
    }
  }, {
    key: 'initBackground',
    value: function initBackground() {
      var viewport = this.viewport;

      this.sprites.background = _terminalKit.ScreenBuffer.create({
        width: viewport.width,
        height: viewport.height
      });
    }
  }, {
    key: 'draw',
    value: function draw() {
      var _sprites = this.sprites;
      var background = _sprites.background;
      var currentCard = _sprites.currentCard;
      var viewport = this.viewport;
      var term = this.term;
      var count = this._count;
      var validCount = this._validCount;
      var percent = this._percent;

      // debug(this.sprites.background)
      background.draw({ dst: viewport, tile: true });
      // currentCard.draw({
      //   dst: viewport
      //   , blending: true
      // });
      console.log(this._nextCard);
      viewport.draw({ delta: true });
      debug('#draw');
      // debug(background)
      term.moveTo.eraseLine.bgWhite.green(1, 1, 'results: ' + validCount + ' of ' + count + ', ' + percent + '%');
    }
  }, {
    key: 'animate',
    value: function animate() {
      debug('#animate');
      this.draw();
      // nextPosition();
      setTimeout(this.animate.bind(this), 50);
    }
  }, {
    key: 'checkCard',
    value: function checkCard(value) {
      var key = this._cardKey;

      if (value === key) this.valid();else this.invalid();
    }
  }, {
    key: 'calcPercent',
    value: function calcPercent() {
      this._percent = Math.round(this._validCount / this._count * 100);
    }
  }, {
    key: 'valid',
    value: function valid() {
      var ctx = this;
      this._validCount++;
      this.calcPercent();
      return (0, _co2['default'])(_regeneratorRuntime.mark(function callee$2$0() {
        return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
          while (1) switch (context$3$0.prev = context$3$0.next) {
            case 0:
              context$3$0.next = 2;
              return say.speakAsync(VOICE, 'Good job!');

            case 2:
              ctx.emit('nextcard');

            case 3:
            case 'end':
              return context$3$0.stop();
          }
        }, callee$2$0, this);
      }));
    }
  }, {
    key: 'invalid',
    value: function invalid() {
      var ctx = this;
      this._count++;
      this.calcPercent();
      return (0, _co2['default'])(_regeneratorRuntime.mark(function callee$2$0() {
        return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
          while (1) switch (context$3$0.prev = context$3$0.next) {
            case 0:
              context$3$0.next = 2;
              return say.speakAsync(VOICE, 'Try again!');

            case 2:
            case 'end':
              return context$3$0.stop();
          }
        }, callee$2$0, this);
      }));
    }
  }, {
    key: 'inputs',
    value: function inputs(key) {
      var sprites = this.sprites;

      if (key.match(/[a-z]/)) return this.checkCard(key);
      switch (key) {
        case 'CTRL_C':
          this.terminate();
          break;
      }
    }
  }, {
    key: 'terminate',
    value: function terminate() {
      var term = this.term;

      //term.fullscreen( false ) ;
      term.hideCursor(false);
      term.grabInput(false);
      (0, _co2['default'])(_regeneratorRuntime.mark(function callee$2$0() {
        return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
          while (1) switch (context$3$0.prev = context$3$0.next) {
            case 0:
              // yield say.speakAsync('Alex','hola Santy');
              setTimeout(function () {
                term.moveTo(1, term.height, '\n\n');
                process.exit();
              }, 100);

            case 1:
            case 'end':
              return context$3$0.stop();
          }
        }, callee$2$0, this);
      }));
    }
  }]);

  return App;
})(_fbemitter.EventEmitter);

exports['default'] = App;
module.exports = exports['default'];