import { ScreenBuffer } from 'terminal-kit';
import _Promise from 'bluebird';
import _imageToAscii from 'image-to-ascii';
import path from 'path';
import co from 'co';
import _ from 'lodash';
import foreach from 'generator-foreach';
const debug = require('debug')('assets')
const fs = _Promise.promisifyAll(require('fs'));

function imageToAscii(opts){
  return new Promise(function(resolve, reject) {
    debug(opts)
    _imageToAscii(opts, function(err, result){
      if(err)
      return reject(err);
      return resolve(result);
    })
  })
}

function* exec(){
  let assetDir = path.resolve('./assets');
  debug(assetDir)
  let assets = fs.readdirSync(assetDir);
  let ascii = {};
  let opts = {
    size: {
      height: 17
    }
  }
  assets = assets.map((file) => {
    return path.resolve(`./assets/${file}`)
  })
  assets = _.filter(assets, (file)=>{
    return file.match(/\.png$/)
  })
  // debug(assets)
  yield* foreach(assets, function* (image){
    debug(image)
    opts.path = image;
    let asciiImg;
    asciiImg = yield imageToAscii(opts);
    image = image.match(/([A-Z])\.png$/)[1];
    debug(asciiImg)
    // let buffer = ScreenBuffer.createFromChars({}, asciiImg);
    // debug(buffer.dump())
    // buffer.saveSync(path.resolve(`./dist/buffers/${image}.sbuf`));
    fs.writeFileSync(path.resolve(`./dist/buffers/${image}.txt`), asciiImg);

    // ascii[image] = asciiImg;
  })
  // debug(ascii)
}

co(function*(){
  yield exec()
})
